#include <stdio.h>
#define ull unsigned long long


ull N,Q;
long long A[1000005],L,R,K;

int main()
{
    scanf("%d%d",&N,&Q);
    for(int i=0;i<N;i++) scanf("%d",&A[i]);
    for(int i=0;i<Q;i++){
     scanf("%d%d",&L,&R);
     K=A[L-1];
     for(int j=L+1;j<=R;j++){
      K=K&A[j-1];
     }
     printf("%d\n",K);
    }

    return 0;
}